<?php
namespace Example\RedirectTest\Controller;

use Example\RedirectTest\Utility\MailerUtility;
use TYPO3\CMS\Extbase\Mvc\Controller\ActionController;

/*
 * This file is part of the TYPO3 CMS project.
 *
 * It is free software; you can redistribute it and/or modify it under
 * the terms of the GNU General Public License, either version 2
 * of the License, or any later version.
 *
 * For the full copyright and license information, please read the
 * LICENSE.txt file that was distributed with this source code.
 *
 * The TYPO3 project - inspiring people to share!
 */

class FormController extends ActionController
{
    public function showAction(): void
    {
        // nothing to do just show the form
    }

    public function redirectAction(): void
    {
        $mailData = [
            'sender' => $this->settings['senderEmail'],
            'senderName' => $this->settings['senderName'],
            'subject' => $this->settings['subject'],
            'receivers' => explode(',', $this->settings['receiverEmails']),
            'html' => '<h1>Redirect Test</h1>',
        ];

        if (MailerUtility::send($mailData)) {
            $this->redirect(
                null,
                null,
                null,
                null,
                $this->settings['redirectPageId']
            );
        }
    }
}
