<?php
defined('TYPO3_MODE') || die();

(static function () {
    $vendor = 'Example';
    $extensionKey = 'redirect_test';
    $pluginPrefix = 'redirecttest_';
    $plugins = [
        [
            'name' => 'P1',
            'title' => 'Redirect Test Plugin',
            'flexForm' => true,
            'flexFormExcludeOptions' => 'layout,select_key,recursive',
        ],
    ];

    foreach ($plugins as $plugin) {
        \TYPO3\CMS\Extbase\Utility\ExtensionUtility::registerPlugin(
            $vendor . '.' . $extensionKey,
            $plugin['name'],
            $plugin['title']
        );

        if (isset($plugin['flexForm']) && $plugin['flexForm']) {
            $pluginNameLowercase = $pluginPrefix . strtolower($plugin['name']);
            /**
             * Adds flex form layout to the plugin
             */
            $GLOBALS['TCA']['tt_content']['types']['list']['subtypes_addlist'][$pluginNameLowercase] = 'pi_flexform';
            $GLOBALS['TCA']['tt_content']['types']['list']['subtypes_excludelist'][$pluginNameLowercase] = $plugin['flexFormExcludeOptions'];
            \TYPO3\CMS\Core\Utility\ExtensionManagementUtility::addPiFlexFormValue(
                $pluginNameLowercase,
                'FILE:EXT:' . $extensionKey . '/Configuration/FlexForms/' . $plugin['name'] . '.xml'
            );
        }
    }
})();
